package administracio;

import java.io.IOException;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Arrays;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import InterfazBD.OracleBD;

import fw.taglib.UIComponent;
import fw.faces.AbstractForm;
import fw.faces.stackForms;
import fw.taglib.TagButton;
import fw.taglib.TagButton.UITextButtonComponent;
import fw.taglib.TagTable.UITagTable;

public class usuaris extends AbstractForm {

	public static String C_ACCIO_MODIFICAR="1";
	public static String C_ACCIO_CREAR="0";
	
	
	public void PreProcesPeticio(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms) {

		if (!isPostBack()) {
			OracleBD baseDades = null;
			try {

				baseDades = new OracleBD().conectar();
				UITagTable tbldades = (UITagTable) getComponentByName("tbldades");
				tbldades.clear();
				tbldades.addCapcelera("");
				tbldades.addCapcelera("Codi");
				tbldades.addCapcelera("Nom");
				tbldades.addCapcelera("Cognom");
				tbldades.addCapcelera("Usuari");
				tbldades.addCapcelera("Contrasenya");
				tbldades.addCapcelera("Perfil");

				String sql = "select * from usuaris";

				ResultSet rsDades = baseDades.consulta(sql);
				creaFiles(rsDades);
			} catch (Exception e) {
				System.out.println("Soy un peeetteee " + e.getMessage());
			} finally {
				baseDades.Tancar();

			}

		}

	}

	public void btnbuscar_onclick(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		OracleBD baseDades = null;
		try {

			baseDades = new OracleBD().conectar();
			UITagTable tbldades = (UITagTable) getComponentByName("tbldades");
			UIComponent txtcodi = getComponentByName("txtcodi");
			UIComponent txtnom = getComponentByName("txtnom");
			UIComponent txtcognom = getComponentByName("txtcognom");
			UIComponent txtperfil = getComponentByName("txtperfil");
			UIComponent txtusu = getComponentByName("txtusu");
			UIComponent txtcontra = getComponentByName("txtcontra");
			tbldades.clear();
			tbldades.addCapcelera("");
			tbldades.addCapcelera("Codi");
			tbldades.addCapcelera("Nom");
			tbldades.addCapcelera("Cognom");
			tbldades.addCapcelera("Usuari");
			tbldades.addCapcelera("Contrasenya");
			tbldades.addCapcelera("Perfil");

			String sql = "select * from usuaris ";
			boolean bWhere = false;
			if (!txtcodi.getValue().isEmpty()) {
				sql = sql.concat("WHERE Codi='" + txtcodi.getValue() + "' ");
				bWhere = true;
			}
			if (!txtnom.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("nom='" + txtnom.getValue() + "' ");
			}

			if (!txtcognom.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("cognom='" + txtcognom.getValue() + "' ");
			}
			if (!txtperfil.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("perfil='" + txtperfil.getValue() + "' ");
			}
			if (!txtusu.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("usuari='" + txtusu.getValue() + "' ");
			}
			if (!txtcontra.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("contrasenya='" + txtcontra.getValue() + "' ");
			}

			ResultSet rsDades = baseDades.consulta(sql);

			creaFiles(rsDades);

		} catch (Exception e) {
			msgBox(e.getMessage());
		} finally {
			baseDades.Tancar();

		}

	}

	private void creaFiles(ResultSet rsDades) throws IOException,
			ServletException {
		boolean bdades = false;
		String strButton;
		String strcode;
		UITagTable tbldades = (UITagTable) getComponentByName("tbldades");
	
		try {
			while (rsDades.next()) {
				bdades = true;
				strcode="btn"	+ rsDades.getObject("Codi").toString();
				if (!ContainsComponent(strcode)){
					TagButton tg=new TagButton();
					TagButton.UITextButtonComponent btnComponent =tg.Instaciate();
					
					btnComponent.setName(strcode);
					btnComponent.setValue(rsDades.getObject("Codi").toString() );
					
					addComponent(strcode, btnComponent);
				}
				strButton = "<input type='button' value='>' text='"
						+ rsDades.getObject("Codi").toString() + "' name='"	+ strcode + "' "
						+ createServerAction("onclick", "onclick_modifica")
						+ ">";
				tbldades.addRow(new ArrayList<String>(Arrays.asList(strButton,
						rsDades.getObject("Codi").toString(), rsDades
								.getObject("Nom").toString(), rsDades
								.getObject("Cognom").toString(), rsDades
								.getObject("Usuari").toString(), rsDades
								.getObject("Contrasenya").toString(), rsDades
								.getObject("Perfil").toString())));

			}

			if (!bdades)
				msgBox("NO s'HAN TROBAT DADES PER LA CONSULTA");
		} catch (IOException e) {
			msgBox(e.getMessage());
		} catch (Exception e) {
			msgBox(e.getMessage());
		}
	}

	public void onclick_modifica(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		try {
			
			UIComponent hdAccio = getComponentByName("hdAccio");
			UIComponent hdCodi = getComponentByName("hdCodi");
			hdCodi.setValue(Sender.getValue());
			hdAccio.setValue(C_ACCIO_MODIFICAR);
			
			Navigate("/administracio/usuarisItem.jsp");
		} catch (IOException | ServletException e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
		} catch (Exception e) {
			System.out.println("Soy un peeetteee " + e.getMessage());
		}

	}

	public void btnnou_onclick(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		try {
			UIComponent hdAccio = getComponentByName("hdAccio");
			UIComponent hdCodi = getComponentByName("hdCodi");
			
			hdAccio.setValue(C_ACCIO_CREAR);
			Navigate("/administracio/usuarisItem.jsp");
		} catch (IOException | ServletException e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
		} catch (Exception e) {
			System.out.println("Soy un peeetteee " + e.getMessage());
		}

	}

}
