package administracio;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import InterfazBD.OracleBD;

import fw.taglib.TagButton;
import fw.taglib.UIComponent;
import fw.faces.AbstractForm;
import fw.faces.stackForms;
import fw.taglib.TagTable.UITagTable;

public class usuarisItem extends AbstractForm {

	private String CurrentAcion;
	private String CurrentCodi;

	public void PreProcesPeticio(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms) throws Exception {
		UIComponent txtcodi = getComponentByName("txtcodi");
		txtcodi.setDisabled(false);
		if (!isPostBack()){
			// Recuperem el from pare
			usuaris FormPare = (usuaris) objStackForms.getAntecesor()
					.getFormulariClass();
	
			UIComponent hdAccio = FormPare.getComponentByName("hdAccio");
			UIComponent hdCodi = FormPare.getComponentByName("hdCodi");
	
			CurrentCodi = hdCodi.getValue();
	
			
	
			if (hdAccio.getValue().equals(usuaris.C_ACCIO_MODIFICAR)) {
				CurrentAcion = usuaris.C_ACCIO_MODIFICAR;
				txtcodi.setDisabled(true);
				txtcodi.setValue(CurrentCodi);
				recuperaUsuari(CurrentCodi) ;
			} else {
				CurrentAcion = usuaris.C_ACCIO_CREAR;
				txtcodi.setDisabled(false);
			}
		}
	}

	public void btnAcceptar_onclick(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		if (CurrentAcion.equals(usuaris.C_ACCIO_MODIFICAR)) {
			modificaUsuari();
		} else {
			nouUsuari();
		}

	}

	private void recuperaUsuari(String codi) throws Exception {

		OracleBD baseDades = null;
		try {

			baseDades = new OracleBD().conectar();
			String sql = "select * from usuaris ";
			sql = sql.concat("WHERE Codi='" + codi + "' ");
			ResultSet rsDades = baseDades.consulta(sql);

			UIComponent txtcodi = getComponentByName("txtcodi");
			UIComponent txtnom = getComponentByName("txtnom");
			UIComponent txtcognom = getComponentByName("txtcognom");
			UIComponent txtperfil = getComponentByName("txtperfil");
			UIComponent txtusu = getComponentByName("txtusu");
			UIComponent txtcontra = getComponentByName("txtcontra");

			while (rsDades.next()) {
				txtcodi.setValue(rsDades.getObject("Codi").toString());
				txtnom.setValue(rsDades.getObject("Nom").toString());
				txtcognom.setValue(rsDades.getObject("Cognom").toString());
				txtusu.setValue(rsDades.getObject("Usuari").toString());
				txtcontra.setValue(rsDades.getObject("Contrasenya").toString());
				txtperfil.setValue(rsDades.getObject("Perfil").toString());

			}
		} catch (Exception e) {
			msgBox(e.getMessage());
			throw e;
		} finally {

			try {
				baseDades.Tancar();
			} catch (Exception e) {

			}

		}

	}

	private void nouUsuari() throws IOException, ServletException {
		OracleBD baseDades = null;
		try {

			UIComponent txtcodi = getComponentByName("txtcodi");
			UIComponent txtnom = getComponentByName("txtnom");
			UIComponent txtcognom = getComponentByName("txtcognom");
			UIComponent txtperfil = getComponentByName("txtperfil");
			UIComponent txtusu = getComponentByName("txtusu");
			UIComponent txtcontra = getComponentByName("txtcontra");

			if (Validadar(txtcodi.getValue(), txtusu.getValue(),
					txtcontra.getValue(), txtperfil.getValue())) {
				baseDades = new OracleBD().conectar();
				String Sql = "INSERT INTO USUARIS (codi, nom, cognom, usuari, contrasenya, perfil )";
				Sql = Sql.concat("VALUES('" + txtcodi.getValue() + "','"
						+ txtnom.getValue() + "','" + txtcognom.getValue()
						+ "','" + txtusu.getValue() + "','"
						+ txtcontra.getValue() + "','" + txtperfil.getValue()
						+ "')");
				System.out.println(Sql);
				baseDades.executa(Sql);
				msgBox("LA OPERACI S'HA REALITZAT CORRECTAMENT");
			}

		} catch (IOException e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
		} catch (Exception e) {
			msgBox(e.getMessage());
			throw e;
		} finally {

			try {
				baseDades.Tancar();
			} catch (Exception e) {

			}

		}

	}

	private void modificaUsuari() throws IOException, ServletException {
		OracleBD baseDades = null;
		try {

			UIComponent txtcodi = getComponentByName("txtcodi");
			UIComponent txtnom = getComponentByName("txtnom");
			UIComponent txtcognom = getComponentByName("txtcognom");
			UIComponent txtperfil = getComponentByName("txtperfil");
			UIComponent txtusu = getComponentByName("txtusu");
			UIComponent txtcontra = getComponentByName("txtcontra");

			if (Validadar(txtcodi.getValue(), txtusu.getValue(),txtcontra.getValue(), txtperfil.getValue())) {
				baseDades = new OracleBD().conectar();
				String Sql = "UPDATE USUARIS SET ";
				Sql = Sql.concat("nom='" + txtnom.getValue() + "', ");
				Sql = Sql.concat("cognom='" + txtcognom.getValue() + "', ");
				Sql = Sql.concat("usuari='" + txtusu.getValue() + "', ");
				Sql = Sql.concat("contrasenya='" + txtcontra.getValue() + "', ");
				Sql = Sql.concat("perfil='" + txtperfil.getValue() + "' ");
				Sql = Sql.concat("WHERE codi='" + txtcodi.getValue() + "'");
						
				baseDades.executa(Sql);
				msgBox("LA OPERACI S'HA REALITZAT CORRECTAMENT");
			}

		} catch (IOException e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
		} catch (Exception e) {
			msgBox(e.getMessage());
			throw e;
		} finally {

			try {
				baseDades.Tancar();
			} catch (Exception e) {
				System.out.println("Soy un peeetteee " + e.getMessage());
			}

		}

	}

	public boolean Validadar(String codi, String usuari, String contrasenya,
			String perfil) throws IOException, ServletException {
		boolean result = true;
		String strMessage = "";

		if (codi.isEmpty()) {
			strMessage = strMessage.concat("- El camp codi no pot ser blanc\n");
			result = false;
		}
		if (usuari.isEmpty()) {
			strMessage = strMessage
					.concat("- El camp usuari no pot ser blanc\n");
			result = false;
		}
		if (contrasenya.isEmpty()) {
			strMessage = strMessage
					.concat("- El camp contrasenya no pot ser blanc\n");
			result = false;
		}
		if (perfil.isEmpty()) {
			strMessage = strMessage
					.concat("- El camp perfil no pot ser blanc\n");
			result = false;
		}
		if (!result)
			msgBox(strMessage);

		return result;

	}

	public void btnCancelar_onclick(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		try {

			Navigate("/administracio/usuaris.jsp");
		} catch (IOException | ServletException e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
		} catch (Exception e) {
			System.out.println("Soy un peeetteee " + e.getMessage());
		}

	}

}
