package fw.taglib;

import java.io.IOException;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;





public class TagButton extends AbstractTag{

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 8490596495303258640L;
	
	
	 public TagButton(){
		 super();
		 
		 super.Component = new UITextButtonComponent(); 
		 
	 }
	 
	 
	 public int doStartTag() throws JspException {
		 	String htmlOut="";
		 	
	        try{
	        	htmlOut="<input type=\"button\" ";
	        	htmlOut=htmlOut.concat(super.getHTMLAtributes());
	        	htmlOut=htmlOut.concat(super.getHTMLEvents());
	        	htmlOut=htmlOut.concat(" />");
	        	        	
	            pageContext.getOut().print(htmlOut);
	         
	        } catch (IOException e) {
	            throw new JspException ("Error: IOException" +   e.getMessage());
	        }
	        
	        return SKIP_BODY;
	    }
		
	 	public int doEndTag() throws JspException {
	    	return super.doEndTag();
	        
	    }
	    
	    
		  public UITextButtonComponent Instaciate(){
		    	return new UITextButtonComponent();
		    }
		  
		  public class UITextButtonComponent extends UIComponent{
	    	public String getPostbackConserveMethod(){
				return "setValue";
			}
	    	
	    }
	
}
