package fw.taglib;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class TagHidden extends AbstractTag{

	private static final long serialVersionUID = 1L;

	public TagHidden(){
		
		super.Component=new UITextTagHidden();
		
	}
	
	public int doStartTag() throws JspException {
		  
		 	String htmlOut="";
		 	
		 	super.doStartTag();
		 	
	        try{
	        	
	        	htmlOut="<input type=\"hidden\"";
	        	htmlOut=htmlOut.concat(super.getHTMLAtributes());
	        	htmlOut=htmlOut.concat(super.getHTMLEvents());
	        	htmlOut=htmlOut.concat(" >");
	        	        	
	            pageContext.getOut().print(htmlOut);
	         
	        } catch (IOException e) {
	            throw new JspException ("Error: IOException" +   e.getMessage());
	        }
	        
	        return SKIP_BODY;
	    }
		
	    public int doEndTag() throws JspException {
	    	return super.doEndTag();
	        
	    }
	   
	    
	    public UIComponent Instaciate(){
	    	return new UITextTagHidden();
	    }

	    private class UITextTagHidden extends UIComponent{
	    	public String getPostbackConserveMethod(){
				return "setValue";
			}
	    }
	
}
