package fw.taglib;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.TagSupport;

public class TagLink extends AbstractTag{

	
	
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5672858727072915858L;

	public TagLink(){
		
		super.Component=new UILinkComponent();
		
	}
	
	public int doStartTag() throws JspException {
		  
		 	String htmlOut="";
		 	
		 	super.doStartTag();
		 	
	        try{
	        	//htmlOut=<a href="#" onclick="jscript:carrega('http://localhost:8080/Framework_Presentacio_MLC/ServletFacade/administracio/usuaris.jsp');"><span>Usuaris</span></a>
	        	
	        	htmlOut="<a ";
	        	htmlOut=htmlOut.concat(super.getHTMLAtributes());
	        	htmlOut=htmlOut.concat(super.getHTMLEvents());
	        	htmlOut=htmlOut.concat(" >");
	        	        	
	            pageContext.getOut().print(htmlOut);
	         
	        } catch (IOException e) {
	            throw new JspException ("Error: IOException" +   e.getMessage());
	        } 
	        
	        return EVAL_BODY_BUFFERED;
	    }
	
	public int doAfterBody() throws JspException {
		String htmlOut="";

		try {
			BodyContent bodycontent = getBodyContent();
			JspWriter out = bodycontent.getEnclosingWriter();
			htmlOut=htmlOut.concat("<span>");
			htmlOut=htmlOut.concat(bodycontent.getString());			
			htmlOut=htmlOut.concat("</span>");
			htmlOut=htmlOut.concat("</a>");
			out.print(htmlOut);
			
		} catch (IOException ioe) {
			throw new JspException("Error:" + ioe.getMessage());
		}
		return SKIP_BODY;
	}
		
	    public int doEndTag() throws JspException {
	    	return super.doEndTag();
	        
	    }
	   
	    
	    public UIComponent Instaciate(){
	    	return new UILinkComponent();
	    }

	    private class UILinkComponent extends UIComponent{
	    	public String getPostbackConserveMethod(){
				return "setValue";
			}
	    }
	
}
