package productes;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import InterfazBD.OracleBD;

import fw.taglib.TagButton;
import fw.taglib.UIComponent;
import fw.faces.AbstractForm;
import fw.faces.stackForms;
import fw.taglib.TagTable.UITagTable;

public class productesItem extends AbstractForm {

	private String CurrentAcion;
	private String CurrentCodi;

	public void PreProcesPeticio(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms) throws Exception {
		UIComponent txtcodi = getComponentByName("txtcodi");
		txtcodi.setDisabled(false);
		if (!isPostBack()){
			// Recuperem el from pare
			productes FormPare = (productes) objStackForms.getAntecesor()
					.getFormulariClass();
	
			UIComponent hdAccio = FormPare.getComponentByName("hdAccio");
			UIComponent hdCodi = FormPare.getComponentByName("hdCodi");
	
			CurrentCodi = hdCodi.getValue();
	
			
	
			if (hdAccio.getValue().equals(productes.C_ACCIO_MODIFICAR)) {
				CurrentAcion = productes.C_ACCIO_MODIFICAR;
				txtcodi.setDisabled(true);
				txtcodi.setValue(CurrentCodi);
				recuperaProducte(CurrentCodi) ;
			} else {
				CurrentAcion = productes.C_ACCIO_CREAR;
			}
		}
	}

	public void btnAcceptar_onclick(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		if (CurrentAcion.equals(productes.C_ACCIO_MODIFICAR)) {
			modificaProducte();
		} else {
			nouProducte();
		}

	}

	private void recuperaProducte(String codi) throws Exception {

		OracleBD baseDades = null;
		try {

			baseDades = new OracleBD().conectar();
			String sql = "select * from productes ";
			sql = sql.concat("WHERE Codi='" + codi + "' ");
			ResultSet rsDades = baseDades.consulta(sql);

			UIComponent txtcodi = getComponentByName("txtcodi");
			UIComponent txtnom = getComponentByName("txtnom");
			UIComponent txtstock = getComponentByName("txtstock");
			UIComponent txtfamilia = getComponentByName("txtfamilia");
			UIComponent txtpreu = getComponentByName("txtpreu");
			

			while (rsDades.next()) {
				txtcodi.setValue(rsDades.getObject("Codi").toString());
				txtnom.setValue(rsDades.getObject("Nom").toString());
				txtstock.setValue(rsDades.getObject("stock").toString());
				txtfamilia.setValue(rsDades.getObject("familia").toString());
				txtpreu.setValue(rsDades.getObject("preu").toString());
				

			}
		} catch (Exception e) {
			msgBox(e.getMessage());
			throw e;
		} finally {

			try {
				baseDades.Tancar();
			} catch (Exception e) {

			}

		}

	}

	private void nouProducte() throws IOException, ServletException {
		OracleBD baseDades = null;
		try {

			UIComponent txtcodi = getComponentByName("txtcodi");
			UIComponent txtnom = getComponentByName("txtnom");
			UIComponent txtstock = getComponentByName("txtstock");
			UIComponent txtfamilia = getComponentByName("txtfamilia");
			UIComponent txtpreu = getComponentByName("txtpreu");

			if (Validadar(txtcodi.getValue(), txtnom.getValue(),
					txtpreu.getValue(), txtfamilia.getValue())) {
				baseDades = new OracleBD().conectar();
				String Sql = "INSERT INTO PRODUCTES (codi, nom, stock, familia, preu )";
				Sql = Sql.concat("VALUES('" + txtcodi.getValue() + "','"
						+ txtnom.getValue() + "','" + txtstock.getValue()
						+ "','" + txtfamilia.getValue() + "','"
						+ txtpreu.getValue()
						+ "')");
				
				baseDades.executa(Sql);
				msgBox("LA OPERACI S'HA REALITZAT CORRECTAMENT");
			}

		} catch (IOException e) {
			msgBox(e.getMessage());
			throw e;
		} catch (Exception e) {
			msgBox(e.getMessage());
			throw e;
		} finally {

			try {
				baseDades.Tancar();
			} catch (Exception e) {

			}

		}

	}

	private void modificaProducte() throws IOException, ServletException {
		OracleBD baseDades = null;
		try {

			UIComponent txtcodi = getComponentByName("txtcodi");
			UIComponent txtnom = getComponentByName("txtnom");
			UIComponent txtstock = getComponentByName("txtstock");
			UIComponent txtfamilia = getComponentByName("txtfamilia");
			UIComponent txtpreu = getComponentByName("txtpreu");

			if (Validadar(txtcodi.getValue(), txtnom.getValue(),
					txtpreu.getValue(), txtfamilia.getValue())) {
				baseDades = new OracleBD().conectar();
				String Sql = "UPDATE USUARIS SET ";
				Sql = Sql.concat("nom='" + txtnom.getValue() + "', ");
				Sql = Sql.concat("stock='" + txtstock.getValue() + "', ");
				Sql = Sql.concat("familia='" + txtfamilia.getValue() + "', ");
				Sql = Sql.concat("preu='" + txtpreu.getValue() + "' ");
				Sql = Sql.concat("WHERE codi='" + txtcodi.getValue() + "'");
						
				baseDades.executa(Sql);
				msgBox("LA OPERACI S'HA REALITZAT CORRECTAMENT");
			}

		} catch (IOException e) {
			msgBox(e.getMessage());
			throw e;
		} catch (Exception e) {
			msgBox(e.getMessage());
			throw e;
		} finally {

			try {
				baseDades.Tancar();
			} catch (Exception e) {
				
			}

		}

	}

	public boolean Validadar(String codi, String nom, String preu,
			String familia) throws IOException, ServletException {
		boolean result = true;
		String strMessage = "";

		if (codi==null) {
			strMessage = strMessage.concat("- El camp codi no pot ser blanc\n");
			result = false;
		}
		if (nom==null) {
			strMessage = strMessage
					.concat("- El camp nom no pot ser blanc\n");
			result = false;
		}
		if (preu==null) {
			strMessage = strMessage
					.concat("- El camp preu no pot ser blanc\n");
			result = false;
		}
		if (familia==null) {
			strMessage = strMessage.concat("- El camp familia no pot ser blanc\n");
			result = false;
		}
		if (!result)
			msgBox(strMessage);

		return result;

	}

	public void btnCancelar_onclick(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		try {

			Navigate("/productes/productes.jsp");
		} catch (IOException | ServletException e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
		} catch (Exception e) {
			System.out.println("Soy un peeetteee " + e.getMessage());
		}

	}

}
