package InterfazBD;

import java.sql.*;



public class OracleBD {

    private Connection conexion;

    public OracleBD conectar() {
        try { 
        	//Connection conexion = DriverManager.getConnection("jdbc:oracle:thin:@192.168.56.101:1521:ORCL", "AVANCE2","AVANCE2");

        	 Class.forName("oracle.jdbc.OracleDriver");       
        	 String BaseDeDatos = "jdbc:oracle:thin:@192.168.56.101:1521:ORCL";             
        	 conexion = DriverManager.getConnection(BaseDeDatos, "AVANCE2","AVANCE2");            
        
            if (conexion != null) {
                System.out.println("Conexion OK!");
            } else {
                System.out.println("Conexion KO!");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return this;
    }

    public boolean executa(String sql) {
        try {
            Statement sentencia;
            sentencia = getConexion().createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
            sentencia.executeUpdate(sql);
            getConexion().commit();
            sentencia.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    public ResultSet consulta(String sql) {
        ResultSet resultado = null;
        try {
            Statement sentencia;
            sentencia = getConexion().createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
            resultado = sentencia.executeQuery(sql);
            getConexion().commit();
        } catch (SQLException e) {
            e.printStackTrace();
            return null;
        }
        return resultado;
    }

    public Connection getConexion() {
        return conexion;
    }

    public void setConexion(Connection conexion) {
        this.conexion = conexion;
    }
    
    public void Tancar() {
    	try{
    		if(this.conexion!=null)
    			if (!this.conexion.isClosed())
    					this.conexion.close();
    	}catch(Exception e){}
    	catch(Throwable e){}
    }

    
    
}
