package fw.taglib;

import java.io.IOException;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.TagSupport;



public class TagDiv extends AbstractTag {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6510365814273355004L;

	public TagDiv() {
		super();

		super.Component = new UIDivComponent();

	}

	public int doStartTag() throws JspException {
		String htmlOut = "";
		super.doStartTag();
		try {
			htmlOut = "<span ";
			htmlOut = htmlOut.concat(super.getHTMLAtributes());
			htmlOut = htmlOut.concat(super.getHTMLEvents());
			htmlOut = htmlOut.concat(" >");

			pageContext.getOut().print(htmlOut);

		} catch (IOException e) {
			throw new JspException("Error: IOException" + e.getMessage());
		}

		return EVAL_BODY_BUFFERED;
	}

	public int doEndTag() throws JspException {
		return super.doEndTag();
	}

	public int doAfterBody() throws JspException {


		try {
			BodyContent bodycontent = getBodyContent();
			String htmlOut = bodycontent.getString();
			JspWriter out = bodycontent.getEnclosingWriter();
			htmlOut=htmlOut.concat("</span>");
			out.print(htmlOut);
			
		} catch (IOException ioe) {
			throw new JspException("Error:" + ioe.getMessage());
		}
		return SKIP_BODY;
	}

	  public UIComponent Instaciate(){
	    	return new UIDivComponent();
	    }

	private class UIDivComponent extends UIComponent {
		public String getPostbackConserveMethod(){
			return null;
		}
	}

}
