package fw.taglib;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.TagSupport;

public class TagTable extends AbstractTag{

	
	
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5672858727072915858L;

	public TagTable(){
		
		super.Component=new UITagTable();
		
	}
	
	public int doStartTag() throws JspException {
		  
		 	String htmlOut="";
		 	
		 	super.doStartTag();
		 	UITagTable TagComponent =(UITagTable) Component;
		 	ArrayList<String> lstCapcelera=TagComponent.getCapcelera();
		 	ArrayList<ArrayList> lstCos=TagComponent.getFiles();
	        try{
	        	//htmlOut=<a href="#" onclick="jscript:carrega('http://localhost:8080/Framework_Presentacio_MLC/ServletFacade/administracio/usuaris.jsp');"><span>Usuaris</span></a>
	        	
	        	htmlOut=htmlOut.concat("<Table border=1>");
	        	//afegim la capcelera
	        	htmlOut=htmlOut.concat("<tr>");
	        	Iterator<String> itcap=lstCapcelera.iterator();
	        	while(itcap.hasNext()){
	        		htmlOut=htmlOut.concat("<Th>" + itcap.next() +"</Th>");
	        		
	        	}
	        	htmlOut=htmlOut.concat("</tr>");
	        	//afegim les rows	        	
	        	Iterator<ArrayList> itcos=lstCos.iterator();
	        	ArrayList row;
	        	while(itcos.hasNext()){
	        		row= itcos.next();
	        		htmlOut=htmlOut.concat("<tr>");
	        		for(int i=0; i<row.size();i++){
	        			htmlOut=htmlOut.concat("<Td>" + row.get(i) +"</Td>");
	        		}
	        		htmlOut=htmlOut.concat("</tr>");
	        	}
	        	
	        	
	        	htmlOut=htmlOut.concat("<Table>");
	            pageContext.getOut().print(htmlOut);
	         
	        } catch (IOException e) {
	            throw new JspException ("Error: IOException" +   e.getMessage());
	        } 
	        
	        return EVAL_BODY_BUFFERED;
	    }
	
	public int doAfterBody() throws JspException {
		String htmlOut="";

		try {
			BodyContent bodycontent = getBodyContent();
			JspWriter out = bodycontent.getEnclosingWriter();
			htmlOut=htmlOut.concat("<span>");
			htmlOut=htmlOut.concat(bodycontent.getString());			
			htmlOut=htmlOut.concat("</span>");
			htmlOut=htmlOut.concat("</a>");
			out.print(htmlOut);
			
		} catch (IOException ioe) {
			throw new JspException("Error:" + ioe.getMessage());
		}
		return SKIP_BODY;
	}
		
	    public int doEndTag() throws JspException {
	    	return super.doEndTag();
	        
	    }
	   
	    
	    public UIComponent Instaciate(){
	    	return new UITagTable();
	    }

	    public class UITagTable extends UIComponent{
	    	
	    	private ArrayList<String> lstCapcelera=new ArrayList<String>();
	    	private ArrayList<ArrayList> lstCos=new ArrayList<ArrayList>();
	    	
	    	public String getPostbackConserveMethod(){
				return "setValue";
			}
	    	
	    	protected ArrayList<String> getCapcelera(){
	    		return lstCapcelera;
	    	}
	    	
	    	protected ArrayList<ArrayList> getFiles(){
	    		return lstCos;
	    	}
	    	
	    	public void addCapcelera(String value){
	    		lstCapcelera.add(value);	
	    	}
	    	
	    	public void clear(){
	    		lstCos=new ArrayList<ArrayList>();
	    		lstCapcelera=new ArrayList<String>();
	    	}
	    	
	    	public void clearCos(){
	    		lstCos=new ArrayList<ArrayList>();
	    	}
	    	
	    	public void clearCapcelera(){
	    		lstCapcelera=new ArrayList<String>();
	    	}
	    	public void addRow(ArrayList<String> value) throws Exception{
	    		if (value.size()!= lstCapcelera.size())
	    			throw new Exception ("Les files han de tindre " + lstCapcelera.size() + " registres");
	    		lstCos.add(value);	
	    	}
	    }
	
}
