package productes;

import java.io.IOException;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Arrays;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import InterfazBD.OracleBD;

import fw.taglib.UIComponent;
import fw.faces.AbstractForm;
import fw.faces.stackForms;
import fw.taglib.TagButton;
import fw.taglib.TagButton.UITextButtonComponent;
import fw.taglib.TagTable.UITagTable;

public class productes extends AbstractForm {

	public static String C_ACCIO_MODIFICAR="1";
	public static String C_ACCIO_CREAR="0";
	
	
	public void PreProcesPeticio(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms) {

		if (!isPostBack()) {
			OracleBD baseDades = null;
			try {

				baseDades = new OracleBD().conectar();
				UITagTable tbldades = (UITagTable) getComponentByName("tbldades");
				tbldades.clear();
				tbldades.addCapcelera("");
				tbldades.addCapcelera("Codi");
				tbldades.addCapcelera("Nom");
				tbldades.addCapcelera("Stock");
				tbldades.addCapcelera("Familia");
				tbldades.addCapcelera("Preu");
				

				String sql = "select * from productes";

				ResultSet rsDades = baseDades.consulta(sql);
				creaFiles(rsDades);
			} catch (Exception e) {

			} finally {
				baseDades.Tancar();

			}

		}

	}

	public void btnbuscar_onclick(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		OracleBD baseDades = null;
		try {

			baseDades = new OracleBD().conectar();
			UITagTable tbldades = (UITagTable) getComponentByName("tbldades");
			UIComponent txtcodi = getComponentByName("txtcodi");
			UIComponent txtnom = getComponentByName("txtnom");
			UIComponent txtstock = getComponentByName("txtstock");
			UIComponent txtfamilia = getComponentByName("txtfamilia");
			UIComponent txtpreu = getComponentByName("txtpreu");
			
			tbldades.clear();
			tbldades.addCapcelera("");
			tbldades.addCapcelera("Codi");
			tbldades.addCapcelera("Nom");
			tbldades.addCapcelera("Stock");
			tbldades.addCapcelera("Familia");
			tbldades.addCapcelera("Preu");

			String sql = "select * from productes ";
			boolean bWhere = false;
			if (!txtcodi.getValue().isEmpty()) {
				sql = sql.concat("WHERE Codi='" + txtcodi.getValue() + "' ");
				bWhere = true;
			}
			if (!txtnom.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("nom='" + txtnom.getValue() + "' ");
			}

			if (!txtstock.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("stock='" + txtstock.getValue() + "' ");
			}
			if (!txtfamilia.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("familia='" + txtfamilia.getValue() + "' ");
			}
			if (!txtpreu.getValue().isEmpty()) {
				if (!bWhere) {
					sql = sql.concat("WHERE ");
					bWhere = true;
				} else
					sql = sql.concat("AND ");
				sql = sql.concat("preu='" + txtpreu.getValue() + "' ");
			}
			
			ResultSet rsDades = baseDades.consulta(sql);
			creaFiles(rsDades);

		} catch (Exception e) {
			msgBox(e.getMessage());
		} finally {
			baseDades.Tancar();

		}

	}

	private void creaFiles(ResultSet rsDades) throws IOException,
			ServletException {
		boolean bdades = false;
		String strButton;
		String strcode;
		UITagTable tbldades = (UITagTable) getComponentByName("tbldades");
	
		try {
			while (rsDades.next()) {
				bdades = true;
				strcode="btn"	+ rsDades.getObject("Codi").toString();
				if (!ContainsComponent(strcode)){
					TagButton tg=new TagButton();
					TagButton.UITextButtonComponent btnComponent =tg.Instaciate();
					
					btnComponent.setName(strcode);
					btnComponent.setValue(rsDades.getObject("Codi").toString() );
					
					addComponent(strcode, btnComponent);
				}
				strButton = "<input type='button' value='>' text='"
						+ rsDades.getObject("Codi").toString() + "' name='"	+ strcode + "' "
						+ createServerAction("onclick", "onclick_modifica")
						+ ">";
				tbldades.addRow(new ArrayList<String>(Arrays.asList(strButton,
						rsDades.getObject("Codi").toString(), rsDades
								.getObject("Nom").toString(), rsDades
								.getObject("stock").toString(), rsDades
								.getObject("familia").toString(), rsDades
								.getObject("preu").toString())));

			}

			if (!bdades)
				msgBox("NO s'HAN TROBAT DADES PER LA CONSULTA");
		} catch (IOException e) {
			msgBox(e.getMessage());
		} catch (Exception e) {
			msgBox(e.getMessage());
		}
	}

	public void onclick_modifica(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		try {
			UIComponent hdAccio = getComponentByName("hdAccio");
			UIComponent hdCodi = getComponentByName("hdCodi");
			hdCodi.setValue(Sender.getValue());
			hdAccio.setValue(C_ACCIO_MODIFICAR);
			
			Navigate("/productes/productesItem.jsp");
		} catch (IOException | ServletException e) {
			e.printStackTrace();
			msgBox(e.getMessage());
		} catch (Exception e) {
			msgBox(e.getMessage());
		}

	}

	public void btnnou_onclick(HttpServletRequest SerRequest,
			HttpServletResponse SerResponse, stackForms objStackForms,
			UIComponent Sender) throws IOException, ServletException {

		try {
			UIComponent hdAccio = getComponentByName("hdAccio");
			UIComponent hdCodi = getComponentByName("hdCodi");
			hdAccio.setValue(C_ACCIO_CREAR);

			Navigate("/productes/productesItem.jsp");
		} catch (IOException | ServletException e) {
			msgBox(e.getMessage());
		} catch (Exception e) {
			msgBox(e.getMessage());
		}

	}

}
